/********************************** (C) COPYRIGHT *********************************
* File Name          : CH395.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395ʾ
**********************************************************************************/

/**********************************************************************************
CH395 TCP/IP Эӿ
MSC51 ʾʾ4socket ֱʹUDP,TCP Client,TCP ServerԼIP RAW ,Ƭ
յݺ󣬰λȡϴMCS51@24MHZ,KEIL 4
**********************************************************************************/
/* ͷļ*/
#include <reg52.h>
#include "stdio.h"
#include "string.h"
#include "../PUB/CH395INC.H"
#include "CH395.H"

/**********************************************************************************/
/*
CH395_OP_INTERFACE_MODEΪ1-5
1Ӳ߲ӷʽ
2ģⲢӷʽ
3: ӲSPIӷʽ
4: ģSPIʽ
5: Ӳ첽ӷʽ
*/
#define   CH395_OP_INTERFACE_MODE             3                     
#if   (CH395_OP_INTERFACE_MODE == 1)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_HW.C"                                           
#elif (CH395_OP_INTERFACE_MODE == 2)                                 /* SEL = 0, TX = 1*/
#include "../PUB/CH395PARA_SW.C"                                            
#elif (CH395_OP_INTERFACE_MODE == 3)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_HW.C"
#elif (CH395_OP_INTERFACE_MODE == 4)                                 /* SEL = 1, TX = 0*/
#include "../PUB/CH395SPI_SW.C"
#elif (CH395_OP_INTERFACE_MODE == 5)                                 /* SEL = 1, TX = 1*/
#include "../PUB/CH395UART.C"
#else
#error "Please Select Correct Communication Interface "
#endif

/**********************************************************************************/
/* ļ */
#include "../PUB/CH395CMD.C"

#define     CH395_DEBUG                0
/* ñ */
UINT8 xdata MyBuffer[4][100];                                        /* ݻ ,ݻȿɸݵƬԴʵ,ͨѶٶ*/
struct _SOCK_INF xdata SockInf[4];                                   /* SocketϢ */
struct _CH395_SYS xdata CH395Inf;                                    /* CH395Ϣ */

/* CH395ض */
const UINT8 CH395IPAddr[4] = {192,168,1,10};                         /* CH395IPַ */
const UINT8 CH395GWIPAddr[4] = {192,168,1,1};                        /* CH395 */
const UINT8 CH395IPMask[4] = {255,255,255,0};                        /* CH395 */

/* socket ض,Ϊʾsocket0-2Դ˿ںĿĶ˿,socket3 */
/* ΪIP RAWҪIP ЭֶεЭ */
const UINT8  Socket0DesIP[4] = {192,168,1,100};                      /* Socket 0ĿIPַ */
const UINT16 Socket0DesPort = 1000;                                  /* Socket 0ĿĶ˿ */
const UINT16 Socket0SourPort = 5000;                                 /* Socket 0Դ˿ */

const UINT8  Socket1DesIP[4] = {192,168,1,100};                      /* Socket 1ĿIPַ */
const UINT16 Socket1SourPort = 6000;                                 /* Socket 1Դ˿ */

const UINT8  Socket2DesIP[4] = {192,168,1,100};                      /* Socket 2ĿIPַ */
const UINT16 Socket2DesPort = 3000;                                  /* Socket 2ĿĶ˿ */
const UINT16 Socket2SourPort = 7000;                                 /* Socket 2Դ˿ */

const UINT8  Socket3DesIP[4] = {192,168,1,100};                      /* Socket 3ĿIPַ */
const UINT8  IPRawProto = 0xE2; 
                                                                     /* IPЭ */

/**********************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ룬ͣ
* Input          : iError   
* Output         : None
* Return         : None
**********************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CMD_ERR_SUCCESS) return;                           /* ɹ */
#if CH395_DEBUG
    printf("Error: %02X\n", (UINT16)iError);                         /* ʾ */
#endif
    while ( 1 ) 
    {
        mDelaymS(200);
        mDelaymS(200);
    }
}

/**********************************************************************************
* Function Name  : InitCH395InfParam
* Description    : ʼCH395Inf
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitCH395InfParam(void)
{
    memset(&CH395Inf,0,sizeof(CH395Inf));                            /* CH395Infȫ*/
    memcpy(CH395Inf.IPAddr,CH395IPAddr,sizeof(CH395IPAddr));         /* IPַдCH395Inf */
    memcpy(CH395Inf.GWIPAddr,CH395GWIPAddr,sizeof(CH395GWIPAddr));   /* IPַдCH395Inf */
    memcpy(CH395Inf.MASKAddr,CH395IPMask,sizeof(CH395IPMask));       /* дCH395Inf */
}

/**********************************************************************************
* Function Name  : InitSocketParam
* Description    : ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void InitSocketParam(void)
{
    memset(&SockInf[0],0,sizeof(SockInf[0]));                        /* SockInf[0]ȫ*/
    memcpy(SockInf[0].IPAddr,Socket0DesIP,sizeof(Socket0DesIP));     /* ĿIPַд */
    SockInf[0].DesPort = Socket0DesPort;                             /* ĿĶ˿ */
    SockInf[0].SourPort = Socket0SourPort;                           /* Դ˿ */
    SockInf[0].ProtoType = PROTO_TYPE_UDP;                           /* UDPģʽ */

    memset(&SockInf[1],0,sizeof(SockInf[1]));                        /* SockInf[1]ȫ*/
    SockInf[1].SourPort = Socket1SourPort;                           /* Դ˿ */
    SockInf[1].ProtoType = PROTO_TYPE_TCP;                           /* TCPģʽ */
    SockInf[1].TcpMode = TCP_SERVER_MODE;                            /* TCPģʽ */

    memset(&SockInf[2],0,sizeof(SockInf[2]));                        /* SockInf[2]ȫ*/
    memcpy(SockInf[2].IPAddr,Socket2DesIP,sizeof(Socket2DesIP));     /* ĿIPַд */
    SockInf[2].DesPort = Socket2DesPort;                             /* ĿĶ˿ */
    SockInf[2].SourPort = Socket2SourPort;                           /* Դ˿ */
    SockInf[2].ProtoType = PROTO_TYPE_TCP;                           /* TCPģʽ */
    SockInf[2].TcpMode = TCP_CLIENT_MODE;                            /* TCPͻģʽ */

    memset(&SockInf[3],0,sizeof(SockInf[3]));                        /* SockInf[3]ȫ*/
    memcpy(SockInf[3].IPAddr,Socket3DesIP,sizeof(Socket3DesIP));     /* ĿIPַд */
    SockInf[3].ProtoType = PROTO_TYPE_IP_RAW;                        /* IPRAW */
}

/**********************************************************************************
* Function Name  : CH395SocketInitOpen
* Description    : CH395 socket ʼsocket
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInitOpen(void)
{
    UINT8 i;

    /* socket 0ΪUDPģʽ */
    CH395SetSocketDesIP(0,SockInf[0].IPAddr);                        /* socket 0ĿIPַ */         
    CH395SetSocketProtType(0,PROTO_TYPE_UDP);                        /* socket 0Э */
    CH395SetSocketDesPort(0,SockInf[0].DesPort);                     /* socket 0ĿĶ˿ */
    CH395SetSocketSourPort(0,SockInf[0].SourPort);                   /* socket 0Դ˿ */
    i = CH395OpenSocket(0);                                          /* socket 0 */
    mStopIfError(i);

    /* socket 1ΪTCP Serverģʽ,ĿIPԴ˿ */
    CH395SetSocketProtType(1,PROTO_TYPE_TCP);                        /* socket 1Э */
    CH395SetSocketSourPort(1,SockInf[1].SourPort);                   /* socket 1Դ˿ */
    i = CH395OpenSocket(1);                                          /* socket 1 */
    mStopIfError(i);                                                 /* Ƿɹ */
    i = CH395TCPListen (1);                                          /* ʼ */
    mStopIfError(i);                                                 /* Ƿɹ */

    /* socket 2ΪTCP Clientģʽ */
    CH395SetSocketDesIP(2,SockInf[2].IPAddr);                        /* socket 2ĿIPַ */
    CH395SetSocketProtType(2,PROTO_TYPE_TCP);                        /* socket 2Э */
    CH395SetSocketDesPort(2,SockInf[2].DesPort);                     /* socket 2ĿĶ˿ */
    CH395SetSocketSourPort(2,SockInf[2].SourPort);                   /* socket 2Դ˿ */
    i = CH395OpenSocket(2);                                          /* socket 2 */
    mStopIfError(i);                                                 /* Ƿɹ */
    i = CH395TCPConnect(2);                                          /* ʼ */
    mStopIfError(i);                                                 /* Ƿɹ,ʧܣsocketر */

    /* socket 3ΪIP RAWģʽ */
    CH395SetSocketDesIP(3,SockInf[3].IPAddr);                        /* socket 3ĿIPַ */
    CH395SetSocketProtType(3,PROTO_TYPE_IP_RAW);                     /* IP RAWģʽµIPЭֶ */
    CH395SetSocketIPRAWProto(3,IPRawProto);                          /* Эֶ */
    i = CH395OpenSocket(3);                                          /* socket 3 */
    mStopIfError(i);                                                 /* Ƿɹ */
}

/**********************************************************************************
* Function Name  : CH395SocketInterrupt
* Description    : CH395 socket ж,ȫжб
* Input          : sockindex  Socket
* Output         : None
* Return         : None
**********************************************************************************/
void CH395SocketInterrupt(UINT8 sockindex)
{
    UINT8  sock_int_socket;
    UINT8  i;
    UINT16 len;
    UINT16 tmp;
    UINT8 idata buf[10];

    sock_int_socket = CH395GetSocketInt(sockindex);                  /* ȡsocket ж״̬ */
    if(sock_int_socket & SINT_STAT_SENBUF_FREE)                      /* ͻУԼдҪ͵ */
    {

    }
    if(sock_int_socket & SINT_STAT_SEND_OK)                          /* ж */
    {
    }
    if(sock_int_socket & SINT_STAT_RECV)                             /* ж */
    {
        len = CH395GetRecvLength(sockindex);                         /* ȡǰݳ */
#if CH395_DEBUG
        printf("receive len = %d\n"	,len);
#endif
        if(len == 0)return;
        if(len > 100)len = 100;                                      /* ͻΪ2048 */
        CH395GetRecvData(sockindex,len,MyBuffer[sockindex]);         /* ȡ */
        for(tmp =0; tmp < len; tmp++)                                /* ݰλȡ */
        {
            MyBuffer[sockindex][tmp] = ~MyBuffer[sockindex][tmp];
        }
        CH395SendData(sockindex,MyBuffer[sockindex],len);

   }
   if(sock_int_socket & SINT_STAT_CONNECT)                            /* жϣTCPģʽЧ*/
   {
#if CH395_DEBUG
       printf("Tcp Connect\n");
#endif
       if(SockInf[sockindex].TcpMode == TCP_SERVER_MODE)              /* socket ΪģʽûԻȡԶ˵IPͶ˿*/
       {
           CH395CMDGetRemoteIPP(sockindex,buf);
           tmp = (UINT16)(buf[5]<<8) + buf[4];
#if CH395_DEBUG
	       printf("IP address = %d.%d.%d.%d\n",(UINT16)buf[0],(UINT16)buf[1],(UINT16)buf[2],(UINT16)buf[3]);                    
	       printf("Port = %d\n",tmp);    
#endif

       }
   }
   /*
   **ϿжϺͳʱжʱCH395ĬڲرգûҪԼرոSocketóɲرSocketҪ
   **SOCK_CTRL_FLAG_SOCKET_CLOSE־λĬΪ0ñ־Ϊ1CH395ڲSocketйرմûжϺͳʱжʱ
   **CH395CloseSocketSocketйرգرSocketһֱΪӵ״̬ʵѾϿͲȥˡ
   */
   if(sock_int_socket & SINT_STAT_DISCONNECT)                        /* ϿжϣTCPģʽЧ */
   {
		//i = CH395CloseSocket(sockindex);                             
		//mStopIfError(i);
   }
   if(sock_int_socket & SINT_STAT_TIM_OUT)                           /* ʱжϣTCPģʽЧ */
   {
		//i = CH395CloseSocket(sockindex);
		//mStopIfError(i);
       if(SockInf[sockindex].TcpMode == TCP_CLIENT_MODE)             
       {
           mDelaymS(200);                                            /* ʱ200MSٴԣûбҪƵ */
           i = CH395OpenSocket(sockindex);
           mStopIfError(i);
           CH395TCPConnect(sockindex);                               /* ʼ */
           mStopIfError(i);
       }
    }
}

/********************************************************************************
* Function Name  : CH395GlobalInterrupt
* Description    : CH395ȫжϺ
* Input          : None
* Output         : None
* Return         : None
*********************************************************************************/
void CH395GlobalInterrupt(void)
{
   UINT16  init_status;
   UINT8  buf[10]; 
 
    init_status = CH395CMDGetGlobIntStatus_ALL();
    if(init_status & GINT_STAT_UNREACH)                              /* ɴжϣȡɴϢ */
    {
        CH395CMDGetUnreachIPPT(buf);           
    }
    if(init_status & GINT_STAT_IP_CONFLI)                            /* IPͻжϣ޸CH395 IPʼCH395*/
    {
    }
    if(init_status & GINT_STAT_PHY_CHANGE)                           /* PHYıж*/
    {
#if CH395_DEBUG
        printf("Init status : GINT_STAT_PHY_CHANGE\n");
#endif
	}
    if(init_status & GINT_STAT_SOCK0)
    {
        CH395SocketInterrupt(0);                                     /* socket 0ж*/
    }
    if(init_status & GINT_STAT_SOCK1)                               
    {
        CH395SocketInterrupt(1);                                     /* socket 1ж*/
    }
    if(init_status & GINT_STAT_SOCK2)                                
    {
        CH395SocketInterrupt(2);                                     /* socket 2ж*/
    }
    if(init_status & GINT_STAT_SOCK3)                                
    {
        CH395SocketInterrupt(3);                                     /* socket 3ж*/
    }
    if(init_status & GINT_STAT_SOCK4)
    {
        CH395SocketInterrupt(4);                                     /* socket 4ж*/
    }
    if(init_status & GINT_STAT_SOCK5)                                
    {
        CH395SocketInterrupt(5);                                     /* socket 5ж*/
    }
    if(init_status & GINT_STAT_SOCK6)                                
    {
        CH395SocketInterrupt(6);                                     /* socket 6ж*/
    }
    if(init_status & GINT_STAT_SOCK7)                                
    {
        CH395SocketInterrupt(7);                                     /* socket 7ж*/
    }
}

/**********************************************************************************
* Function Name  : CH395Init
* Description    : CH395IP,GWIP,MACȲʼ
* Input          : None
* Output         : None
* Return         : ִн
**********************************************************************************/
UINT8  CH395Init(void)
{
    UINT8 i;
    
    i = CH395CMDCheckExist(0x65);   
    if(i != 0x9a)return CH395_ERR_UNKNOW;                            /* ޷ͨ0XFA */
                                                                     /* 0XFAһΪӲ߶дʱ򲻶 */
#if (CH395_OP_INTERFACE_MODE == 5)                                   
#ifdef UART_WORK_BAUDRATE
    CH395CMDSetUartBaudRate(UART_WORK_BAUDRATE);                     /* ò */   
    mDelaymS(1);
    SetMCUBaudRate();
#endif
#endif
    CH395CMDSetIPAddr(CH395Inf.IPAddr);                              /* CH395IPַ */
    CH395CMDSetGWIPAddr(CH395Inf.GWIPAddr);                          /* صַ */
    CH395CMDSetMASKAddr(CH395Inf.MASKAddr);                          /* 룬ĬΪ255.255.255.0*/   
    mDelaymS(10);
    i = CH395CMDInitCH395();                                         /* ʼCH395оƬ */
    return i;
}

/**********************************************************************************
* Function Name  : mInitSTDIO
* Description    : ڳʼ,ʹ
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
void mInitSTDIO( void )
{
    SCON = 0x50;
    PCON = 0x80;
    TMOD = 0x21;
    TH1 = 0xf3;                                                      /* 24MHz, 9600bps */
    TR1 = 1;
    TI = 1;
}

/**********************************************************************************
* Function Name  : main
* Description    : main
* Input          : None
* Output         : None
* Return         : None
**********************************************************************************/
int main(void)
{
    UINT8 i;
    mDelaymS(100);
    mInitSTDIO();                                                    /* ʱ100 */ 
#if CH395_DEBUG
    printf("CH395EVT Test Demo\n");
#endif
    CH395_PORT_INIT();
    InitCH395InfParam();                                             /* ʼCH395ر */
    i = CH395Init();                                                 /* ʼCH395оƬ */
    mStopIfError(i);                                                                     
  
    while(1)
    {                                                                /* ȴ̫ӳɹ*/
       if(CH395CMDGetPHYStatus() == PHY_DISCONN)                     /* ѯCH395Ƿ */
       {
           mDelaymS(200);                                            /* δȴ200MSٴβѯ */
       }
       else 
       {
#if CH395_DEBUG
           printf("CH395 Connect Ethernet\n");                       /* CH395оƬӵ̫ʱж */
#endif
           break;
       }
    }
    InitSocketParam();                                                /* ʼsocketر */
    CH395SocketInitOpen();
    while(1)
    {
       if(CH395_INT_WIRE == 0)CH395GlobalInterrupt();
    }
}


