/********************************** (C) COPYRIGHT *******************************
* File Name          : CH395SPI_HW.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395оƬ ӲSPIӵӲ V1.0
*                     
*******************************************************************************/

/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH395оƬ
      P1.4                 SCS
      P1.5                 SDI
      P1.6                 SDO
      P1.7                 SCK      */
      
sbit        P14         =          P1^4;
#define CH395_SPI_SCS              P14                               /* CH395SCS */

sfr SPDR = 0x86;                                                     /* SPIݼĴ0x86 */
sfr SPSR = 0xaa;                                                     /* SPI״̬Ĵ0xaa */
sfr SPCR = 0xd5;                                                     /* SPIƼĴ0xd5 */

#define SPI_IF_TRANS    0x80                                         /* SPIֽڴɱ־,SPSRλ7 */

#define CH395_INT_WIRE              INT1                            /* CH395INT# */

#define xCH395CmdStart( )         {CH395_SPI_SCS = 0;}               /* ʼ */
#define xEndCH395Cmd()            {CH395_SPI_SCS = 1;}               /* */

/*******************************************************************************
* Function Name  : mDelayuS
* Description    : ʱָ΢ʱ,ݵƬƵ,ȷ
* Input          : us---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelayuS( UINT8 us )
{
    while( us -- );                                                  /* MCS51@24MHz */
}

/*******************************************************************************
* Function Name  : mDelaymS
* Description    : ʱָʱ,ݵƬƵ,ȷ
* Input          : ms---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS( UINT8 ms )
{
    while( ms -- ) 
    {
        mDelayuS( 250 );
        mDelayuS( 250 );
        mDelayuS( 250 );
        mDelayuS( 250 );
    }
}

/******************************************************************************
* Function Name  : CH395_PORT_INIT
* Description    : Ӳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_PORT_INIT(void)
{
    xEndCH395Cmd();
   /* ӲSPIӿ,ôʹmode3(CPOL=1&CPHA=1)mode0(CPOL=0&CPHA=0),
    CH395ʱز,½,λǸλǰ */
    SPCR = 0x5C;  
    /* ˫I/OģSPIӿ,ôڴSPI_SCS,SPI_SCK,SPI_SDIΪ,
       SPI_SDOΪ뷽 */
    /* SPIģʽ3, DORD=0(MSB first), CPOL=1, CPHA=1, CH395Ҳ֧SPIģʽ0 */
    SPSR |= 0x08;
        
}

/*******************************************************************************
* Function Name  : Spi395Exchange
* Description    : ӲSPI8λ
* Input          : d---Ҫ뵽CH395
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 Spi395Exchange( UINT8 d )  
{  
    /* Ϊٶ,ԽӳɺԼӳò */
    SPDR = d;                                                    /* ȽдSPIݼĴ,ȻѯSPI״̬ĴԵȴSPIֽڴ */
    while( ( SPSR & SPI_IF_TRANS ) == 0 );                       /* ѯSPI״̬ĴԵȴSPIֽڴ */
    SPSR &= ~ SPI_IF_TRANS;                                      /* SPIֽڴɱ־,еĵƬԶ */
    return( SPDR );                                              /* ȲѯSPI״̬ĴԵȴSPIֽڴ,ȻSPIݼĴ */
}

/******************************************************************************
* Function Name  : xWriteCH395Cmd
* Description    : CH395д
* Input          : cmd 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH395Cmd(UINT8 cmd)                                          
{                                                                    
    xEndCH395Cmd();                                                  /* ֹCSԭΪͣȽCDø */
    xCH395CmdStart( );                                               /* ʼCS */
    Spi395Exchange(cmd);                                             /* SPI */
    mDelayuS(2);                                                     /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}

/******************************************************************************
* Function Name  : xWriteCH395Data
* Description    : CH395д
* Input          : mdata 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH395Data(UINT8 mdata)
{   
    Spi395Exchange(mdata);                                           /* SPI */
}

/*******************************************************************************
* Function Name  : xReadCH395Data
* Description    : CH395
* Input          : None
* Output         : None
* Return         : 8λ
*******************************************************************************/
UINT8   xReadCH395Data( void )                                                  
{
    UINT8 i;
    i = Spi395Exchange(0xff);                                        /* SPI */
    return i;
}

/**************************** endfile *************************************/
 