/********************************** (C) COPYRIGHT *******************************
* File Name          : CH395SPI_SW.C
* Author             : WCH
* Version            : V1.1
* Date               : 2014/8/1
* Description        : CH395оƬ ģSPIӵӲ V1.0
*                      
*******************************************************************************/

/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ               CH395оƬ
        P1.4                       SCS
        P1.5                       SDI
        P1.6                       SDO
        P1.7                       SCK                                */
sbit    P14          =             P1^4;
sbit    P15          =             P1^5;
sbit    P16          =             P1^6;
sbit    P17          =             P1^7;
#define CH395_SPI_SCS              P14                               /* CH395SCS */
#define CH395_SPI_SDI              P15                               /* CH395SDI */
#define CH395_SPI_SDO              P16                               /* CH395SDO */
#define CH395_SPI_SCK              P17                               /* CH395SCK */

#define CH395_INT_WIRE             INT1                              /* CH395INT# */

#define xCH395CmdStart( )         {CH395_SPI_SCS = 0;}
#define xEndCH395Cmd()            {CH395_SPI_SCS = 1;}


/********************************************************************************
* Function Name  : mDelayuS
* Description    : ʱָ΢ʱ,ݵƬƵ,ȷ
* Input          : us---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelayuS(UINT8 us)
{
    while(us --);                                                    /* MCS51@24MHz */
}

/*******************************************************************************
* Function Name  : mDelaymS
* Description    : ʱָʱ,ݵƬƵ,ȷ
* Input          : ms---ʱʱֵ
* Output         : None
* Return         : None
*******************************************************************************/
void mDelaymS(UINT8 ms)
{
    while(ms --) 
    {
        mDelayuS(250);
        mDelayuS(250);
        mDelayuS(250);
        mDelayuS(250);
    }
}

/*******************************************************************************
* Function Name  : CH395_PORT_INIT
* Description    : Ӳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH395_PORT_INIT(void)
{
    CH395_SPI_SCS = 1;
    CH395_SPI_SCK = 1;                                               /*  SIP_CLKΪߵƽʹSPIģʽ3Ҳʹģʽ0*/
}

/*******************************************************************************
* Function Name  : Spi395OutByte
* Description    : CH3958λ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Spi395OutByte(UINT8 mdata)                                      /* SPI8λ */
{                                                                    /* ӲSPIֻҪдSPIݼĴ */
    UINT8   i;                                                       /* Ȼȴɼ */

    for ( i = 0; i < 8; i ++ ) 
    {
        CH395_SPI_SCK = 0;                                           /* CLK */
        if( mdata & 0x80 )CH395_SPI_SDI = 1; 
        else CH395_SPI_SDI = 0;
        mdata <<= 1;                                                 /* λǸλǰ */
        CH395_SPI_SCK = 1;                                           /* CH395ʱز */
    }
}

/*******************************************************************************
* Function Name  : Spi395InByte
* Description    : CH3958λ
* Input          : None
* Output         : None
* Return         : 8λ
*******************************************************************************/
UINT8 Spi395InByte(void)                                             /* SPI8λ */
{                                                                    /* ӲSPIӿ,ӦȲѯSPI״̬ĴԵȴSPIֽ*/
    UINT8   i, d;                                                    /* ,ȻSPIݼĴ */
    d = 0;

    for ( i = 0; i < 8; i ++ )  
    {
        CH395_SPI_SCK = 0;                                           /* CH395ʱ½ */
        d <<= 1;  /* λǸλǰ */
        if ( CH395_SPI_SDO) d ++;
        CH395_SPI_SCK = 1;
    }
    return( d );
}

/*******************************************************************************
* Function Name  : xWriteCH395Cmd
* Description    : CH3958λ
* Input          : 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH395Cmd(UINT8 cmd)                                       /* CH395д */
{
    xEndCH395Cmd();                                                  /* ֹCSԭΪͣȽCDø */
    xCH395CmdStart( );                                               /* ʼCS */
    Spi395OutByte(cmd);                                              /* ӲSPI8λ */
    mDelayuS(2);                                                     /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}

/********************************************************************************
* Function Name  : xWriteCH395Data
* Description    : CH3958λ
* Input          : 8λ
* Output         : None
* Return         : None
*******************************************************************************/
void  xWriteCH395Data(UINT8 mdata)                                  /* CH395д */
{   
    Spi395OutByte(mdata);                                                      
}

/********************************************************************************
* Function Name  : xReadCH395Data
* Description    : CH395
* Input          : None 
* Output         : None
* Return         : 8λ
*******************************************************************************/
UINT8   xReadCH395Data( void )                                       /* CH395 */
{
    UINT8 i;
    i = Spi395InByte( );
    return i;
}

/**************************** endfile *************************************/
